;This is content of sample.lsp
(setq a "Test1" b "Test2" c "Test3")
(string a " " b " " c)
(sys-info)
(append "Test1" "Test2")             ;it works also on lists
(assoc 20 (list(list 20 "Dog")(list 30 "CAT")(list 40 "Mice")))
(assoc 20 '((20 "Dog")(30 "CAT")(40 "Mice")))           ;shorter typing
(assoc 20 '((20 Dog)(30 CAT)(40 Mice)))          ;symbols instead of strings
(directory)
(find "world" "Hello world")
(find "WORLD" "Hello woRLd")
(find "WorlD" "Hello woRLd" 1)            ;optional 1 = case insensitiv
(set 'str "this isa sentence")
(replace "isa" str "is a")
(set 'str "ZZZZZxZZZZyy")
;(replace "[x[#124]y]" str "PP" 0)          ;special use bracket with #124 in neobook
(replace "[x|y]" str "PP" 0)          ;no special use bracket
(random 0 1 10)
(sqrt 2)
(regex "b+" "aaaabbbaaaa")            ;Perl regular expressions
;Now here calling neobook actions in newlisp-returns!
;newLSIP-Interface cuts off the string "nb-action " at the beginning
(silent(print "nb-action AlertBox \"Test\" \"This is a 1.Action!\"\nAlertBox \"Test\" \"This is a 2.Action!\"\n"))    ;Double quotes in lisp-string with esc-char \
(string "nb-action AlertBox \"Test\" \"This is a 1.Action!\"\nAlertBox \"Test\" \"This is a 2.Action!\"\n")
"nb-action AlertBox \"Test\" \"This is a 1.Action!\"\nAlertBox \"Test\" \"This is a 2.Action!\"\n"
nl2nb-list           ;Show function code
(nl2nb-list '("1" "2" "3"))          ;sample call
(parse "1|2|3|Test" "|")         ;sample call
;newlisp own DLL-interface calls with 'stdcall' like WIN OS
(import "kernel32.dll" "GetTickCount")
(GetTickCount)

(import "kernel32.dll" "GetComputerNameA")
(set 'str "                                                               ") ; reserve much space 
(set 'lpNum (pack "lu" (length str)))
(GetComputerNameA str lpNum)
(slice str 0 (find "\000" str))


(import "kernel32.dll" "GetWindowsDirectoryA") 
(set 'str "                                                               ") ; reserve much space 
(GetWindowsDirectoryA str (length str)) 
(slice str 0 (find "\000" str))

;Get your WIN-API doc and start playing
(import "user32.dll" "MessageBoxA")
(MessageBoxA 0 "This is the body" "Caption" 1)
(import "user32.dll" "ShowCursor")
(ShowCursor 0)	;Off
(ShowCursor 1)	;ON
; From Sam Cox from the neobook forum
(define (dec2hex n) (silent (print (format {%X} n))))
(dec2hex 15)
; From Sam Cox from the newlisp forum
repchr
(repchr 10 65)
; From Lutz Mueller from the newlisp forum
allocate
(allocate 10)
;(define (allocate n)(join(map(fn(x)" ")(sequence 1 n))))
;(define (allocate n)(pack (string "s" n)" "))
;(time (dotimes (x 1000000) (allocate 50))) 

;; From HPW from the newlisp forum
repstr
(repstr "AB" 10)
MyFirstCustomCommand
(MyFirstCustomCommand)
MySecondCustomCommand
(MySecondCustomCommand {Test1})
MyThirdCustomCommand
(MyThirdCustomCommand {Test1}{Test2})
; From Nigel Brown/Sam Cox from the newlisp forum
ncase
expander
expandit
(ncase "diane" (("bob" "mary" "susie") 'friend) (("tim" "diane") 'boss) ("sam" 'self) ("sammo" 'clever-alias) (true 'stranger))

(set 'winexec (import "shell32.dll" "ShellExecuteA")) 
(winexec 0 "open" "newlisp.exe" "" "" 0) ; hides newlisp shell 
(winexec 0 "open" "newlisp.exe" "" "" 1) ; displays newlisp shell 
(winexec 0 "open" "newlisp.exe" "" "" 2) ; shell is minimized 

(define (dirname path) (if (regex "(.*/).*" path) $1 "./"))
(dirname (replace "\\" (nth 0 (main-args)) "/"))

(define (dirname path) (join (chop (parse path "\\")) "\\"))
(dirname (nth 0 (main-args)))

(define (basename path) (last (parse path "/")))
(define (basename path) (last (parse path "\\")))

(define (foo2 x)
[text]
Doc string
Row2
[/text] (+ x x))
(define (doc f pflag)
[text]This is a function to return/print the documentation of a function from its lambda/macro
Sample call: (doc foo2) or (doc foo2 true)[/text]
   (if (and(or(lambda? f)(macro? f))(string?(nth 1 f)))
      (if pflag
       (begin(print(nth 1 f))(write-line)true)
       (nth 1 f))
      nil))
(doc foo2)

;(load "glut.lsp")

;Testfunctions V2.02
(nbplay {AlertBox "Test" "Test"})

;(define (nbget nbvar nbsize nbvalue) (setq nbvalue(allocate (+ nbsize 1)))(hpwGetVar nbvar nbvalue)(slice nbvalue 0 (find "\000" nbvalue)))
(nbget "[nbNewLispErr]" 20)
(replace "\\" (nbget "[hpwNewLispDllName]" 255) "/")
(nbget "[hpwNewLispDllName]" 255)
(nbget "[NBMode]" 1)
(replace "\\" (nbget "[PubDir]" 255) "/")
(nbget "[PubDir]" 255)
(nbget "[PubAuthor]" 50)
(nbget "[SystemLanguage]" 50)

(nbset "[Myvar1]" "Test1")
(nbset "[Myvar2]" "Test2")
(nbset "[Myvar3]" "99999")

(nbget "[Myvar1]" 20)
(nbget "[Myvar2]" 20)
(nbget "[Myvar3]" 20)

(if (=(nbget "[NBMode]" 1)"R")"Runtime""Design")

(define (show-tree dir counter)
(dolist (nde (directory dir))
   (if (and (directory? (append dir "/" nde)) (!= nde ".") (!= nde ".."))
        (show-tree (append dir "/" nde) (+ counter 1))
        (println counter ": "(append dir "/" nde)))))

;Sam from the forum
(define (random-sequence n m)
    (letn (L (sequence n m) N (length L))
      (map (lambda (x) (pop L x)) (rand N N)) ))

(define (files fpath fpattern intflag)(filter(fn (x)(regex fpattern x intflag))(directory fpath)))

;timer sample
(setq MyTime 10.0)
(define (ticker)(nbset "[ListboxContent]" (string(date))) (if(> MyTime 0.0)(timer 'ticker MyTime))) 

